#pragma once
#include <memory>

namespace Generic {
	template <typename T, typename NodeType>
	class DirectedNode
	{
	public:
		DirectedNode(T value, std::shared_ptr<NodeType> left = nullptr, std::shared_ptr<NodeType> right = nullptr);
		~DirectedNode();
		T value;
		std::shared_ptr<NodeType> left;
		std::shared_ptr<NodeType> right;
	private:

	};
}
