#pragma once
#include <memory>

namespace Generic {
	template <typename T, typename NodeType>
	class UndirectedNode
	{
	public:
		UndirectedNode(T value, std::shared_ptr<NodeType> left = nullptr, std::shared_ptr<NodeType> right = nullptr);
		~UndirectedNode();
		T value;
		std::shared_ptr<NodeType> next;
	private:

	};
}
